import { useMemo } from "react"

const log = console.log
let cache: Array<any> = []

export default <T>(factory: () => T): T => {
    return useMemo(() => {
        if (log === console.log) {
            queueMicrotask(() => cache = [])
            const result = factory()
            cache.push(result)
            return result
        }
        return cache.shift()
    }, [])
}